"use strict";
// created with ❤ by Yaman Katby at 25 Mar 2019.
Object.defineProperty(exports, "__esModule", { value: true });
const utilities_1 = require("./utilities/utilities");
exports.array = (source) => {
    if (source === undefined || !Array.isArray(source)) {
        new TypeError(`Looks like the first parameter that you have passed to the array function isn't an array.`);
    }
    let value = source.slice();
    const push = (...elements) => {
        value = [...value, ...elements];
        return publicAPI;
    };
    const unshift = (...elements) => {
        value = [...elements, ...value];
        return publicAPI;
    };
    const pop = (count = 1) => {
        value = value.slice(0, value.length - count);
        return publicAPI;
    };
    const shift = (count = 1) => {
        value = value.slice(count);
        return publicAPI;
    };
    const concat = (target) => {
        value = [...value, ...target];
        return publicAPI;
    };
    const replace = (index, element) => {
        const indexer = utilities_1.indexify(value, index);
        const target = typeof element === 'function' ? element.call(undefined, value[indexer]) : element;
        value = [...value.slice(0, indexer), target, ...value.slice(indexer + 1)];
        return publicAPI;
    };
    const insertAfter = (index, element) => {
        const indexer = utilities_1.indexify(value, index);
        value = [...value.slice(0, indexer + 1), element, ...value.slice(indexer + 1)];
        return publicAPI;
    };
    const insertBefore = (index, element) => {
        const indexer = utilities_1.indexify(value, index);
        value = [...value.slice(0, indexer), element, ...value.slice(indexer)];
        return publicAPI;
    };
    const remove = (index) => {
        const indexer = utilities_1.indexify(value, index);
        value = [...value.slice(0, indexer), ...value.slice(indexer + 1)];
        return publicAPI;
    };
    const toArray = () => {
        return value;
    };
    const publicAPI = { push, unshift, pop, shift, concat, replace, insertAfter, insertBefore, remove, toArray };
    return publicAPI;
};
